
import palm.conduit.*;
import java.util.*;
import java.io.*;
 
public class HelloCond implements Conduit {

	static final String NAME = "Hello Conduit";

	/** Opens and runs the conduit.
	*/
    	public void open(SyncProperties props)
    	{	
        	// Tell the log we are starting
        	Log.startSync();
		Log.out("Hello conduit: initialize conduit");

      		int db = 0;
      		String dbName = "Hello-VM01";
		String source = "";

        	try {
        		
			// read the source string from the file
			FileReader fr = new FileReader("c:\\j2mewtk\\apps\\HelloMidlet\\in.txt");
			source = (new BufferedReader(fr)).readLine();
			
			// try and create DB
			try
			{
		            	Log.out("HelloCond: creating " + dbName);
				// create integer version of creator id
				int creatorId = 0;
				creatorId |= 'V';creatorId <<=8; creatorId |= 'M'; creatorId <<=8;
				creatorId |= '0'; creatorId <<=8; creatorId |= '1';
			
				// create integer version of type
				int dbType = 0;
				dbType |= 'R';dbType <<=8; dbType |= 'M'; dbType <<=8; dbType |= 'S';
				dbType <<=8; dbType |= 'd';
			
				// crate PDB
				db = SyncManager.createDB(creatorId, 0, 0, dbName, dbType);
			
				// write app info block
				byte[] appInfoBytes = new byte[] { 0, (byte)'H', 0, (byte)'e', 0, (byte)'l',
				0, (byte)'l', 0, (byte)'o' };
			
				SyncManager.writeDBAppInfoBlock (db, dbName, appInfoBytes);					
			}
			catch (Throwable t) { } //do nothing

       			// Open Palm DB
       			Log.out("WebspectCond: opening " + dbName);
       			db = SyncManager.openDB(dbName, 0,
                                    SyncManager.OPEN_READ | SyncManager.OPEN_WRITE | SyncManager.OPEN_EXCLUSIVE);
                                    
                        // write the appropriate record
                        HelloRecord hr = new HelloRecord();
                        hr.setMsg(source);
			hr.setIsNew(true);
			hr.setIsModified(true);
			hr.setIndex(SyncManager.getDBRecordCount(db));
			Record r = (Record) hr;
			r.setId(1);

			SyncManager.writeRec(db, r);

			SyncManager.closeDB(db);
                        

        	} catch (Throwable t) {

            		// If there was an error, dump the stack trace
            		// and tell the log the conduit failed

            		t.printStackTrace();
            		Log.err("WebspectCond: aborting sync");
            		Log.abortSync();
        	}
    	}

	public String name() 
	{
        	return "HelloCond";
    	}

	public int configure(ConfigureConduitInfo info) 
	{
        	return 0;
	}
	
	public class HelloRecord extends AbstractRecord {
	
		String msg;;
	
	    	public String getMsg() 
	    	{
	        	return msg;
	    	}
	
	    	public void setMsg(String msg)
	    	{
	        	this.msg = msg;
	    	}
	
	    	public void writeData(DataOutputStream out) throws IOException
	    	{
	    		Log.out("HelloCond: writing " + msg);
	    		out.writeBytes(msg);
	    	}
	
	    	public void readData(DataInputStream in)
	    	{

	    	}
	}


}
